Merge branch 'maint-2.4' into maint-2.5
[git] / t / test-lib-functions.sh
1 # Library of functions shared by all tests scripts, included by
2 # test-lib.sh.
3 #
4 # Copyright (c) 2005 Junio C Hamano
5 #
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 2 of the License, or
9 # (at your option) any later version.
10 #
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
14 # GNU General Public License for more details.
15 #
16 # You should have received a copy of the GNU General Public License
17 # along with this program.  If not, see http://www.gnu.org/licenses/ .
18
19 # The semantics of the editor variables are that of invoking
20 # sh -c "$EDITOR \"$@\"" files ...
21 #
22 # If our trash directory contains shell metacharacters, they will be
23 # interpreted if we just set $EDITOR directly, so do a little dance with
24 # environment variables to work around this.
25 #
26 # In particular, quoting isn't enough, as the path may contain the same quote
27 # that we're using.
28 test_set_editor () {
29         FAKE_EDITOR="$1"
30         export FAKE_EDITOR
31         EDITOR='"$FAKE_EDITOR"'
32         export EDITOR
33 }
34
35 test_set_index_version () {
36     GIT_INDEX_VERSION="$1"
37     export GIT_INDEX_VERSION
38 }
39
40 test_decode_color () {
41         awk '
42                 function name(n) {
43                         if (n == 0) return "RESET";
44                         if (n == 1) return "BOLD";
45                         if (n == 30) return "BLACK";
46                         if (n == 31) return "RED";
47                         if (n == 32) return "GREEN";
48                         if (n == 33) return "YELLOW";
49                         if (n == 34) return "BLUE";
50                         if (n == 35) return "MAGENTA";
51                         if (n == 36) return "CYAN";
52                         if (n == 37) return "WHITE";
53                         if (n == 40) return "BLACK";
54                         if (n == 41) return "BRED";
55                         if (n == 42) return "BGREEN";
56                         if (n == 43) return "BYELLOW";
57                         if (n == 44) return "BBLUE";
58                         if (n == 45) return "BMAGENTA";
59                         if (n == 46) return "BCYAN";
60                         if (n == 47) return "BWHITE";
61                 }
62                 {
63                         while (match($0, /\033\[[0-9;]*m/) != 0) {
64                                 printf "%s<", substr($0, 1, RSTART-1);
65                                 codes = substr($0, RSTART+2, RLENGTH-3);
66                                 if (length(codes) == 0)
67                                         printf "%s", name(0)
68                                 else {
69                                         n = split(codes, ary, ";");
70                                         sep = "";
71                                         for (i = 1; i <= n; i++) {
72                                                 printf "%s%s", sep, name(ary[i]);
73                                                 sep = ";"
74                                         }
75                                 }
76                                 printf ">";
77                                 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
78                         }
79                         print
80                 }
81         '
82 }
83
84 nul_to_q () {
85         perl -pe 'y/\000/Q/'
86 }
87
88 q_to_nul () {
89         perl -pe 'y/Q/\000/'
90 }
91
92 q_to_cr () {
93         tr Q '\015'
94 }
95
96 q_to_tab () {
97         tr Q '\011'
98 }
99
100 qz_to_tab_space () {
101         tr QZ '\011\040'
102 }
103
104 append_cr () {
105         sed -e 's/$/Q/' | tr Q '\015'
106 }
107
108 remove_cr () {
109         tr '\015' Q | sed -e 's/Q$//'
110 }
111
112 # In some bourne shell implementations, the "unset" builtin returns
113 # nonzero status when a variable to be unset was not set in the first
114 # place.
115 #
116 # Use sane_unset when that should not be considered an error.
117
118 sane_unset () {
119         unset "$@"
120         return 0
121 }
122
123 test_tick () {
124         if test -z "${test_tick+set}"
125         then
126                 test_tick=1112911993
127         else
128                 test_tick=$(($test_tick + 60))
129         fi
130         GIT_COMMITTER_DATE="$test_tick -0700"
131         GIT_AUTHOR_DATE="$test_tick -0700"
132         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
133 }
134
135 # Stop execution and start a shell. This is useful for debugging tests and
136 # only makes sense together with "-v".
137 #
138 # Be sure to remove all invocations of this command before submitting.
139
140 test_pause () {
141         if test "$verbose" = t; then
142                 "$SHELL_PATH" <&6 >&3 2>&4
143         else
144                 error >&5 "test_pause requires --verbose"
145         fi
146 }
147
148 # Call test_commit with the arguments "<message> [<file> [<contents> [<tag>]]]"
149 #
150 # This will commit a file with the given contents and the given commit
151 # message, and tag the resulting commit with the given tag name.
152 #
153 # <file>, <contents>, and <tag> all default to <message>.
154
155 test_commit () {
156         notick= &&
157         signoff= &&
158         while test $# != 0
159         do
160                 case "$1" in
161                 --notick)
162                         notick=yes
163                         ;;
164                 --signoff)
165                         signoff="$1"
166                         ;;
167                 *)
168                         break
169                         ;;
170                 esac
171                 shift
172         done &&
173         file=${2:-"$1.t"} &&
174         echo "${3-$1}" > "$file" &&
175         git add "$file" &&
176         if test -z "$notick"
177         then
178                 test_tick
179         fi &&
180         git commit $signoff -m "$1" &&
181         git tag "${4:-$1}"
182 }
183
184 # Call test_merge with the arguments "<message> <commit>", where <commit>
185 # can be a tag pointing to the commit-to-merge.
186
187 test_merge () {
188         test_tick &&
189         git merge -m "$1" "$2" &&
190         git tag "$1"
191 }
192
193 # This function helps systems where core.filemode=false is set.
194 # Use it instead of plain 'chmod +x' to set or unset the executable bit
195 # of a file in the working directory and add it to the index.
196
197 test_chmod () {
198         chmod "$@" &&
199         git update-index --add "--chmod=$@"
200 }
201
202 # Unset a configuration variable, but don't fail if it doesn't exist.
203 test_unconfig () {
204         git config --unset-all "$@"
205         config_status=$?
206         case "$config_status" in
207         5) # ok, nothing to unset
208                 config_status=0
209                 ;;
210         esac
211         return $config_status
212 }
213
214 # Set git config, automatically unsetting it after the test is over.
215 test_config () {
216         test_when_finished "test_unconfig '$1'" &&
217         git config "$@"
218 }
219
220 test_config_global () {
221         test_when_finished "test_unconfig --global '$1'" &&
222         git config --global "$@"
223 }
224
225 write_script () {
226         {
227                 echo "#!${2-"$SHELL_PATH"}" &&
228                 cat
229         } >"$1" &&
230         chmod +x "$1"
231 }
232
233 # Use test_set_prereq to tell that a particular prerequisite is available.
234 # The prerequisite can later be checked for in two ways:
235 #
236 # - Explicitly using test_have_prereq.
237 #
238 # - Implicitly by specifying the prerequisite tag in the calls to
239 #   test_expect_{success,failure,code}.
240 #
241 # The single parameter is the prerequisite tag (a simple word, in all
242 # capital letters by convention).
243
244 test_set_prereq () {
245         satisfied_prereq="$satisfied_prereq$1 "
246 }
247 satisfied_prereq=" "
248 lazily_testable_prereq= lazily_tested_prereq=
249
250 # Usage: test_lazy_prereq PREREQ 'script'
251 test_lazy_prereq () {
252         lazily_testable_prereq="$lazily_testable_prereq$1 "
253         eval test_prereq_lazily_$1=\$2
254 }
255
256 test_run_lazy_prereq_ () {
257         script='
258 mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
259 (
260         cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
261 )'
262         say >&3 "checking prerequisite: $1"
263         say >&3 "$script"
264         test_eval_ "$script"
265         eval_ret=$?
266         rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
267         if test "$eval_ret" = 0; then
268                 say >&3 "prerequisite $1 ok"
269         else
270                 say >&3 "prerequisite $1 not satisfied"
271         fi
272         return $eval_ret
273 }
274
275 test_have_prereq () {
276         # prerequisites can be concatenated with ','
277         save_IFS=$IFS
278         IFS=,
279         set -- $*
280         IFS=$save_IFS
281
282         total_prereq=0
283         ok_prereq=0
284         missing_prereq=
285
286         for prerequisite
287         do
288                 case "$prerequisite" in
289                 !*)
290                         negative_prereq=t
291                         prerequisite=${prerequisite#!}
292                         ;;
293                 *)
294                         negative_prereq=
295                 esac
296
297                 case " $lazily_tested_prereq " in
298                 *" $prerequisite "*)
299                         ;;
300                 *)
301                         case " $lazily_testable_prereq " in
302                         *" $prerequisite "*)
303                                 eval "script=\$test_prereq_lazily_$prerequisite" &&
304                                 if test_run_lazy_prereq_ "$prerequisite" "$script"
305                                 then
306                                         test_set_prereq $prerequisite
307                                 fi
308                                 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
309                         esac
310                         ;;
311                 esac
312
313                 total_prereq=$(($total_prereq + 1))
314                 case "$satisfied_prereq" in
315                 *" $prerequisite "*)
316                         satisfied_this_prereq=t
317                         ;;
318                 *)
319                         satisfied_this_prereq=
320                 esac
321
322                 case "$satisfied_this_prereq,$negative_prereq" in
323                 t,|,t)
324                         ok_prereq=$(($ok_prereq + 1))
325                         ;;
326                 *)
327                         # Keep a list of missing prerequisites; restore
328                         # the negative marker if necessary.
329                         prerequisite=${negative_prereq:+!}$prerequisite
330                         if test -z "$missing_prereq"
331                         then
332                                 missing_prereq=$prerequisite
333                         else
334                                 missing_prereq="$prerequisite,$missing_prereq"
335                         fi
336                 esac
337         done
338
339         test $total_prereq = $ok_prereq
340 }
341
342 test_declared_prereq () {
343         case ",$test_prereq," in
344         *,$1,*)
345                 return 0
346                 ;;
347         esac
348         return 1
349 }
350
351 test_verify_prereq () {
352         test -z "$test_prereq" ||
353         expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
354         error "bug in the test script: '$test_prereq' does not look like a prereq"
355 }
356
357 test_expect_failure () {
358         test_start_
359         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
360         test "$#" = 2 ||
361         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
362         test_verify_prereq
363         export test_prereq
364         if ! test_skip "$@"
365         then
366                 say >&3 "checking known breakage: $2"
367                 if test_run_ "$2" expecting_failure
368                 then
369                         test_known_broken_ok_ "$1"
370                 else
371                         test_known_broken_failure_ "$1"
372                 fi
373         fi
374         test_finish_
375 }
376
377 test_expect_success () {
378         test_start_
379         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
380         test "$#" = 2 ||
381         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
382         test_verify_prereq
383         export test_prereq
384         if ! test_skip "$@"
385         then
386                 say >&3 "expecting success: $2"
387                 if test_run_ "$2"
388                 then
389                         test_ok_ "$1"
390                 else
391                         test_failure_ "$@"
392                 fi
393         fi
394         test_finish_
395 }
396
397 # test_external runs external test scripts that provide continuous
398 # test output about their progress, and succeeds/fails on
399 # zero/non-zero exit code.  It outputs the test output on stdout even
400 # in non-verbose mode, and announces the external script with "# run
401 # <n>: ..." before running it.  When providing relative paths, keep in
402 # mind that all scripts run in "trash directory".
403 # Usage: test_external description command arguments...
404 # Example: test_external 'Perl API' perl ../path/to/test.pl
405 test_external () {
406         test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
407         test "$#" = 3 ||
408         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
409         descr="$1"
410         shift
411         test_verify_prereq
412         export test_prereq
413         if ! test_skip "$descr" "$@"
414         then
415                 # Announce the script to reduce confusion about the
416                 # test output that follows.
417                 say_color "" "# run $test_count: $descr ($*)"
418                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
419                 # to be able to use them in script
420                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
421                 # Run command; redirect its stderr to &4 as in
422                 # test_run_, but keep its stdout on our stdout even in
423                 # non-verbose mode.
424                 "$@" 2>&4
425                 if test "$?" = 0
426                 then
427                         if test $test_external_has_tap -eq 0; then
428                                 test_ok_ "$descr"
429                         else
430                                 say_color "" "# test_external test $descr was ok"
431                                 test_success=$(($test_success + 1))
432                         fi
433                 else
434                         if test $test_external_has_tap -eq 0; then
435                                 test_failure_ "$descr" "$@"
436                         else
437                                 say_color error "# test_external test $descr failed: $@"
438                                 test_failure=$(($test_failure + 1))
439                         fi
440                 fi
441         fi
442 }
443
444 # Like test_external, but in addition tests that the command generated
445 # no output on stderr.
446 test_external_without_stderr () {
447         # The temporary file has no (and must have no) security
448         # implications.
449         tmp=${TMPDIR:-/tmp}
450         stderr="$tmp/git-external-stderr.$$.tmp"
451         test_external "$@" 4> "$stderr"
452         test -f "$stderr" || error "Internal error: $stderr disappeared."
453         descr="no stderr: $1"
454         shift
455         say >&3 "# expecting no stderr from previous command"
456         if test ! -s "$stderr"
457         then
458                 rm "$stderr"
459
460                 if test $test_external_has_tap -eq 0; then
461                         test_ok_ "$descr"
462                 else
463                         say_color "" "# test_external_without_stderr test $descr was ok"
464                         test_success=$(($test_success + 1))
465                 fi
466         else
467                 if test "$verbose" = t
468                 then
469                         output=$(echo; echo "# Stderr is:"; cat "$stderr")
470                 else
471                         output=
472                 fi
473                 # rm first in case test_failure exits.
474                 rm "$stderr"
475                 if test $test_external_has_tap -eq 0; then
476                         test_failure_ "$descr" "$@" "$output"
477                 else
478                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
479                         test_failure=$(($test_failure + 1))
480                 fi
481         fi
482 }
483
484 # debugging-friendly alternatives to "test [-f|-d|-e]"
485 # The commands test the existence or non-existence of $1. $2 can be
486 # given to provide a more precise diagnosis.
487 test_path_is_file () {
488         if ! test -f "$1"
489         then
490                 echo "File $1 doesn't exist. $2"
491                 false
492         fi
493 }
494
495 test_path_is_dir () {
496         if ! test -d "$1"
497         then
498                 echo "Directory $1 doesn't exist. $2"
499                 false
500         fi
501 }
502
503 # Check if the directory exists and is empty as expected, barf otherwise.
504 test_dir_is_empty () {
505         test_path_is_dir "$1" &&
506         if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
507         then
508                 echo "Directory '$1' is not empty, it contains:"
509                 ls -la "$1"
510                 return 1
511         fi
512 }
513
514 test_path_is_missing () {
515         if test -e "$1"
516         then
517                 echo "Path exists:"
518                 ls -ld "$1"
519                 if test $# -ge 1
520                 then
521                         echo "$*"
522                 fi
523                 false
524         fi
525 }
526
527 # test_line_count checks that a file has the number of lines it
528 # ought to. For example:
529 #
530 #       test_expect_success 'produce exactly one line of output' '
531 #               do something >output &&
532 #               test_line_count = 1 output
533 #       '
534 #
535 # is like "test $(wc -l <output) = 1" except that it passes the
536 # output through when the number of lines is wrong.
537
538 test_line_count () {
539         if test $# != 3
540         then
541                 error "bug in the test script: not 3 parameters to test_line_count"
542         elif ! test $(wc -l <"$3") "$1" "$2"
543         then
544                 echo "test_line_count: line count for $3 !$1 $2"
545                 cat "$3"
546                 return 1
547         fi
548 }
549
550 # This is not among top-level (test_expect_success | test_expect_failure)
551 # but is a prefix that can be used in the test script, like:
552 #
553 #       test_expect_success 'complain and die' '
554 #           do something &&
555 #           do something else &&
556 #           test_must_fail git checkout ../outerspace
557 #       '
558 #
559 # Writing this as "! git checkout ../outerspace" is wrong, because
560 # the failure could be due to a segv.  We want a controlled failure.
561
562 test_must_fail () {
563         "$@"
564         exit_code=$?
565         if test $exit_code = 0; then
566                 echo >&2 "test_must_fail: command succeeded: $*"
567                 return 1
568         elif test $exit_code -gt 129 && test $exit_code -le 192; then
569                 echo >&2 "test_must_fail: died by signal: $*"
570                 return 1
571         elif test $exit_code = 127; then
572                 echo >&2 "test_must_fail: command not found: $*"
573                 return 1
574         elif test $exit_code = 126; then
575                 echo >&2 "test_must_fail: valgrind error: $*"
576                 return 1
577         fi
578         return 0
579 }
580
581 # Similar to test_must_fail, but tolerates success, too.  This is
582 # meant to be used in contexts like:
583 #
584 #       test_expect_success 'some command works without configuration' '
585 #               test_might_fail git config --unset all.configuration &&
586 #               do something
587 #       '
588 #
589 # Writing "git config --unset all.configuration || :" would be wrong,
590 # because we want to notice if it fails due to segv.
591
592 test_might_fail () {
593         "$@"
594         exit_code=$?
595         if test $exit_code -gt 129 && test $exit_code -le 192; then
596                 echo >&2 "test_might_fail: died by signal: $*"
597                 return 1
598         elif test $exit_code = 127; then
599                 echo >&2 "test_might_fail: command not found: $*"
600                 return 1
601         fi
602         return 0
603 }
604
605 # Similar to test_must_fail and test_might_fail, but check that a
606 # given command exited with a given exit code. Meant to be used as:
607 #
608 #       test_expect_success 'Merge with d/f conflicts' '
609 #               test_expect_code 1 git merge "merge msg" B master
610 #       '
611
612 test_expect_code () {
613         want_code=$1
614         shift
615         "$@"
616         exit_code=$?
617         if test $exit_code = $want_code
618         then
619                 return 0
620         fi
621
622         echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
623         return 1
624 }
625
626 # test_cmp is a helper function to compare actual and expected output.
627 # You can use it like:
628 #
629 #       test_expect_success 'foo works' '
630 #               echo expected >expected &&
631 #               foo >actual &&
632 #               test_cmp expected actual
633 #       '
634 #
635 # This could be written as either "cmp" or "diff -u", but:
636 # - cmp's output is not nearly as easy to read as diff -u
637 # - not all diff versions understand "-u"
638
639 test_cmp() {
640         $GIT_TEST_CMP "$@"
641 }
642
643 # test_cmp_bin - helper to compare binary files
644
645 test_cmp_bin() {
646         cmp "$@"
647 }
648
649 # Call any command "$@" but be more verbose about its
650 # failure. This is handy for commands like "test" which do
651 # not output anything when they fail.
652 verbose () {
653         "$@" && return 0
654         echo >&2 "command failed: $(git rev-parse --sq-quote "$@")"
655         return 1
656 }
657
658 # Check if the file expected to be empty is indeed empty, and barfs
659 # otherwise.
660
661 test_must_be_empty () {
662         if test -s "$1"
663         then
664                 echo "'$1' is not empty, it contains:"
665                 cat "$1"
666                 return 1
667         fi
668 }
669
670 # Tests that its two parameters refer to the same revision
671 test_cmp_rev () {
672         git rev-parse --verify "$1" >expect.rev &&
673         git rev-parse --verify "$2" >actual.rev &&
674         test_cmp expect.rev actual.rev
675 }
676
677 # Print a sequence of numbers or letters in increasing order.  This is
678 # similar to GNU seq(1), but the latter might not be available
679 # everywhere (and does not do letters).  It may be used like:
680 #
681 #       for i in $(test_seq 100)
682 #       do
683 #               for j in $(test_seq 10 20)
684 #               do
685 #                       for k in $(test_seq a z)
686 #                       do
687 #                               echo $i-$j-$k
688 #                       done
689 #               done
690 #       done
691
692 test_seq () {
693         case $# in
694         1)      set 1 "$@" ;;
695         2)      ;;
696         *)      error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
697         esac
698         perl -le 'print for $ARGV[0]..$ARGV[1]' -- "$@"
699 }
700
701 # This function can be used to schedule some commands to be run
702 # unconditionally at the end of the test to restore sanity:
703 #
704 #       test_expect_success 'test core.capslock' '
705 #               git config core.capslock true &&
706 #               test_when_finished "git config --unset core.capslock" &&
707 #               hello world
708 #       '
709 #
710 # That would be roughly equivalent to
711 #
712 #       test_expect_success 'test core.capslock' '
713 #               git config core.capslock true &&
714 #               hello world
715 #               git config --unset core.capslock
716 #       '
717 #
718 # except that the greeting and config --unset must both succeed for
719 # the test to pass.
720 #
721 # Note that under --immediate mode, no clean-up is done to help diagnose
722 # what went wrong.
723
724 test_when_finished () {
725         test_cleanup="{ $*
726                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
727 }
728
729 # Most tests can use the created repository, but some may need to create more.
730 # Usage: test_create_repo <directory>
731 test_create_repo () {
732         test "$#" = 1 ||
733         error "bug in the test script: not 1 parameter to test-create-repo"
734         repo="$1"
735         mkdir -p "$repo"
736         (
737                 cd "$repo" || error "Cannot setup test environment"
738                 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
739                 error "cannot run git init -- have you built things yet?"
740                 mv .git/hooks .git/hooks-disabled
741         ) || exit
742 }
743
744 # This function helps on symlink challenged file systems when it is not
745 # important that the file system entry is a symbolic link.
746 # Use test_ln_s_add instead of "ln -s x y && git add y" to add a
747 # symbolic link entry y to the index.
748
749 test_ln_s_add () {
750         if test_have_prereq SYMLINKS
751         then
752                 ln -s "$1" "$2" &&
753                 git update-index --add "$2"
754         else
755                 printf '%s' "$1" >"$2" &&
756                 ln_s_obj=$(git hash-object -w "$2") &&
757                 git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
758                 # pick up stat info from the file
759                 git update-index "$2"
760         fi
761 }
762
763 # This function writes out its parameters, one per line
764 test_write_lines () {
765         printf "%s\n" "$@"
766 }
767
768 perl () {
769         command "$PERL_PATH" "$@"
770 }
771
772 # Is the value one of the various ways to spell a boolean true/false?
773 test_normalize_bool () {
774         git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
775 }
776
777 # Given a variable $1, normalize the value of it to one of "true",
778 # "false", or "auto" and store the result to it.
779 #
780 #     test_tristate GIT_TEST_HTTPD
781 #
782 # A variable set to an empty string is set to 'false'.
783 # A variable set to 'false' or 'auto' keeps its value.
784 # Anything else is set to 'true'.
785 # An unset variable defaults to 'auto'.
786 #
787 # The last rule is to allow people to set the variable to an empty
788 # string and export it to decline testing the particular feature
789 # for versions both before and after this change.  We used to treat
790 # both unset and empty variable as a signal for "do not test" and
791 # took any non-empty string as "please test".
792
793 test_tristate () {
794         if eval "test x\"\${$1+isset}\" = xisset"
795         then
796                 # explicitly set
797                 eval "
798                         case \"\$$1\" in
799                         '')     $1=false ;;
800                         auto)   ;;
801                         *)      $1=\$(test_normalize_bool \$$1 || echo true) ;;
802                         esac
803                 "
804         else
805                 eval "$1=auto"
806         fi
807 }
808
809 # Exit the test suite, either by skipping all remaining tests or by
810 # exiting with an error. If "$1" is "auto", we then we assume we were
811 # opportunistically trying to set up some tests and we skip. If it is
812 # "true", then we report a failure.
813 #
814 # The error/skip message should be given by $2.
815 #
816 test_skip_or_die () {
817         case "$1" in
818         auto)
819                 skip_all=$2
820                 test_done
821                 ;;
822         true)
823                 error "$2"
824                 ;;
825         *)
826                 error "BUG: test tristate is '$1' (real error: $2)"
827         esac
828 }
829
830 # The following mingw_* functions obey POSIX shell syntax, but are actually
831 # bash scripts, and are meant to be used only with bash on Windows.
832
833 # A test_cmp function that treats LF and CRLF equal and avoids to fork
834 # diff when possible.
835 mingw_test_cmp () {
836         # Read text into shell variables and compare them. If the results
837         # are different, use regular diff to report the difference.
838         local test_cmp_a= test_cmp_b=
839
840         # When text came from stdin (one argument is '-') we must feed it
841         # to diff.
842         local stdin_for_diff=
843
844         # Since it is difficult to detect the difference between an
845         # empty input file and a failure to read the files, we go straight
846         # to diff if one of the inputs is empty.
847         if test -s "$1" && test -s "$2"
848         then
849                 # regular case: both files non-empty
850                 mingw_read_file_strip_cr_ test_cmp_a <"$1"
851                 mingw_read_file_strip_cr_ test_cmp_b <"$2"
852         elif test -s "$1" && test "$2" = -
853         then
854                 # read 2nd file from stdin
855                 mingw_read_file_strip_cr_ test_cmp_a <"$1"
856                 mingw_read_file_strip_cr_ test_cmp_b
857                 stdin_for_diff='<<<"$test_cmp_b"'
858         elif test "$1" = - && test -s "$2"
859         then
860                 # read 1st file from stdin
861                 mingw_read_file_strip_cr_ test_cmp_a
862                 mingw_read_file_strip_cr_ test_cmp_b <"$2"
863                 stdin_for_diff='<<<"$test_cmp_a"'
864         fi
865         test -n "$test_cmp_a" &&
866         test -n "$test_cmp_b" &&
867         test "$test_cmp_a" = "$test_cmp_b" ||
868         eval "diff -u \"\$@\" $stdin_for_diff"
869 }
870
871 # $1 is the name of the shell variable to fill in
872 mingw_read_file_strip_cr_ () {
873         # Read line-wise using LF as the line separator
874         # and use IFS to strip CR.
875         local line
876         while :
877         do
878                 if IFS=$'\r' read -r -d $'\n' line
879                 then
880                         # good
881                         line=$line$'\n'
882                 else
883                         # we get here at EOF, but also if the last line
884                         # was not terminated by LF; in the latter case,
885                         # some text was read
886                         if test -z "$line"
887                         then
888                                 # EOF, really
889                                 break
890                         fi
891                 fi
892                 eval "$1=\$$1\$line"
893         done
894 }